unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, IRCSDS, ExtCtrls, dWinsock, Il, buffsock, Menus;

type
  TForm1 = class(TForm)
    IRC: TCustIRC;
    Panel1: TPanel;
    Memo1: TMemo;
    pnlMessage: TPanel;
    Edit1: TEdit;
    pnlTop: TPanel;
    btnConnect: TButton;
    ircServer: TEdit;
    ircPort: TEdit;
    ircChannel: TEdit;
    btnJoin: TButton;
    btnPart: TButton;
    pnlNames: TPanel;
    lbNames: TListBox;
    Edit2: TEdit;
    IRCClient: TTextClient;
    Label1: TLabel;
    Label2: TLabel;
    ilbChat: TIndentListBox;
    cbnew: TCheckBox;
    cbdel: TCheckBox;
    cbcng: TCheckBox;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    procedure btnConnectClick(Sender: TObject);
    procedure IRCPing(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd,
      RcvdMsg: String);
    procedure Edit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure IRCBan(Sender: TObject; PersonKicked, ReasonMsg: String);
    procedure IRCKick(Sender: TObject; PersonKicked, ReasonMsg: String);
    procedure IRCKill(Sender: TObject; PersonKicked, ReasonMsg: String);
    procedure IRCError(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd,
      RcvdMsg: String);
    procedure IRCInvite(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd,
      RcvdMsg: String);
    procedure IRCNotice(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd,
      RcvdMsg: String);
    procedure IRCPrivMsg(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd,
      RcvdMsg: String);
    procedure IRCReply(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd,
      RcvdMsg: String);
    procedure FormCreate(Sender: TObject);
    procedure btnJoinClick(Sender: TObject);
    procedure btnPartClick(Sender: TObject);
    procedure Edit2KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure IRCClientDisconnect(Sender: TObject; Socket: TSocketBase);
    procedure IRCClientConnect(Sender: TObject; Socket: TSocketBase);
    procedure IRCClientLineReceived(socket: TLineSocketBase;
      const line: String; complete: Boolean);
    procedure IRCNickAdd(Sender: TObject; RcvdNick: String);
    procedure IRCNickCng(Sender: TObject; OldNick, NewNick: String);
    procedure IRCNickDel(Sender: TObject; RcvdNick: String);
    procedure IRCJoin(Sender: TObject; RcvdNick, RcvdFrom, RcvdID, RcvdCmd,
      RcvdMsg: String);
    procedure IRCMode(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd,
      RcvdMsg: String);
    procedure IRCNames(Sender: TObject; RcvdName: String);
    procedure IRCNick(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd,
      RcvdMsg: String);
    procedure IRCPart(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd,
      RcvdMsg: String);
    procedure IRCQuit(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd,
      RcvdMsg: String);
    procedure FormDestroy(Sender: TObject);
    procedure IRCMsgLog(Sender: TObject; RcvdNick, RcvdFrom, RcvdID,
      RcvdCmd, RcvdMsg, RcvdLine: String);
    procedure IRCNickSet(Sender: TObject; RcvdNick: String);
    procedure Exit1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
   MsgLog: TStringList;
   procedure SendLine(MsgToSend: String);
   procedure RecvLine(MsgRecvd: String);
   procedure IrcDisconnect;
   procedure AddChatter(msgTitle, msgText: String);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.SendLine(MsgToSend: string);
begin
// Memo3.Lines.Add('*>'+MsgToSend);
 (IRCClient.Conn as TLineSocket).WriteLine(MsgToSend);
end;

procedure TForm1.RecvLine(MsgRecvd: String);
begin
// Memo3.Lines.Add('*<'+MsgRecvd);
 IRC.ParseIncoming(MsgRecvd);
end;

procedure TForm1.btnConnectClick(Sender: TObject);
begin
  if btnConnect.Caption = '&Connect' then
   begin
    IRCServer.Enabled := False;
    IRCPort.Enabled   := False;

    IRCClient.Address := ircServer.Text;
    IRCClient.Port    := ircPort.Text;
    IRC.ChannelName   := ircChannel.Text;

    btnConnect.Caption  := '&Cancel';
    IRCClient.Close;
    IRCClient.Open(TLineSocket);
   end
  else if btnConnect.Caption = '&Cancel' then
   begin
    IRCDisconnect;
   end;
   
end;

procedure TForm1.IRCPing(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd,
  RcvdMsg: String);
begin
 SendLine('PONG '+RcvdMsg);
end;

procedure TForm1.Edit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = vk_Return then
  begin
   SendLine('PRIVMSG '+IRC.ChannelName+','+IRC.NickName+' :'+Edit1.Text);
//   Memo2.Lines.Add('<'+IRC.NickName+'> '+Edit1.Text);
   edit1.Text := '';
 end;
end;

procedure TForm1.IRCBan(Sender: TObject; PersonKicked, ReasonMsg: String);
begin
 Memo1.Lines.Add('BANN <'+PersonKicked+'> '+ ReasonMsg);

 if IRC.NickName = PersonKicked then
  begin
   SendLine('QUIT :Banned from channel or server');
   IRCDisconnect;
  end;

end;

procedure TForm1.IRCKick(Sender: TObject; PersonKicked, ReasonMsg: String);
begin
 Memo1.Lines.Add('KICK <'+PersonKicked+'> '+ ReasonMsg);

 if IRC.NickName = PersonKicked then
  begin
   SendLine('QUIT :Kicked off channel');
   IRCDisconnect;
  end;

end;

procedure TForm1.IRCKill(Sender: TObject; PersonKicked, ReasonMsg: String);
begin
 Memo1.Lines.Add('KILL <'+PersonKicked+'> '+ ReasonMsg);

 if IRC.NickName = PersonKicked then
  begin
   SendLine('QUIT :Killed from Channel or Server');
   IRCDisconnect;
  end;

end;

procedure TForm1.IRCError(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd, RcvdMsg: String);
begin
 Memo1.Lines.Add('ERROR <'+RcvdFrom+' '+RcvdCmd+'> '+ RcvdMsg);
end;

procedure TForm1.IRCInvite(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd, RcvdMsg: String);
begin
 Memo1.Lines.Add('INVITE <'+RcvdFrom+' '+RcvdCmd+'> '+ RcvdMsg);
end;

procedure TForm1.IRCNotice(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd, RcvdMsg: String);
begin
 Memo1.Lines.Add(RcvdMsg);
end;

procedure TForm1.IRCPrivMsg(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd, RcvdMsg: String);
var
 bCut: Integer;
 myloop: Integer;
 whofrom: String;
 bEnding: Integer;
begin
 bEnding:= Pos( '(', RcvdFrom );
 bCut :=0;
 for myloop := 1 to bEnding do
  begin
   inc(bCut);
  end;
 whofrom:=copy( RcvdFrom, 1, bCut-1 );

 AddChatter(whofrom, RcvdMsg);

end;

procedure TForm1.IRCReply(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd, RcvdMsg: String);
begin
  Memo1.Lines.Add(RcvdMsg);

  {376 is command that tell you that you are now registered on this server}
  {* to be changed in TCustumIRC}
  
  if RcvdCmd = '376' then
   btnJoin.Enabled := True;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  MsgLog          := TStringList.Create;
  ircServer.Text  := IRCClient.Address;
  ircPort.Text    := IRCClient.Port;
  ircChannel.Text := IRC.ChannelName;

  memo1.lines.clear;
//  memo2.lines.clear;
//  memo3.lines.clear;
//  memo4.lines.clear;
end;

procedure TForm1.btnJoinClick(Sender: TObject);
begin
 IRCChannel.Enabled := False;
 IRC.ChannelName    := ircChannel.Text;
 lbNames.Items.Clear;
 SendLine('JOIN '+ IRC.ChannelName);
end;

procedure TForm1.btnPartClick(Sender: TObject);
begin
 SendLine('PART '+ IRC.ChannelName);
end;

procedure TForm1.IrcDisconnect;
begin
 IRCClient.Close;
 btnConnect.Caption := '&Connect';

 IRCServer.Enabled := True;
 IRCPort.Enabled   := True;
 btnJoin.Enabled   := False;
 btnPart.Enabled   := False;
end;

procedure TForm1.Edit2KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = vk_Return then
  begin
   SendLine(Edit2.Text);
   edit2.Text := '';
 end;

end;

procedure TForm1.IRCClientDisconnect(Sender: TObject; Socket: TSocketBase);
begin
  IRCDisconnect;
end;

procedure TForm1.IRCClientConnect(Sender: TObject; Socket: TSocketBase);
begin
 if Socket.Connected then
  begin
   memo1.lines.clear;
   if IRC.Password <> '' then SendLine('PASS '+ IRC.Password);
   SendLine('NICK '+ IRC.NickName);
   SendLine('USER '+ IRC.NickName + ' X Y:'+ IRC.UserName);
  end
 else
  begin
   IRCDisconnect;
  end;

end;

procedure TForm1.IRCClientLineReceived(socket: TLineSocketBase;
  const line: String; complete: Boolean);
begin
 RecvLine(Line);
end;

procedure TForm1.IRCNickAdd(Sender: TObject; RcvdNick: String);
begin
 lbNames.Items.Add(RcvdNick);
 if cbNew.Checked then AddChatter('New:', RcvdNick);
end;

procedure TForm1.IRCNickCng(Sender: TObject; OldNick, NewNick: String);
var n: integer;
begin
 if OldNick = IRC.NickName then IRC.NickName := NewNick;

 for n := 0 to lbnames.Items.count -1 do
  if lbnames.items[n] = OldNick then
   begin
    lbnames.items[n] := NewNick;
    if cbcng.checked then AddChatter('Change:', OldNick+' '+NewNick);
   end;

end;

procedure TForm1.IRCNickDel(Sender: TObject; RcvdNick: String);
var n: integer;
begin
 for n := 0 to lbnames.Items.count -1 do
  if lbnames.items[n] = RcvdNick then
   begin
    lbnames.items.delete(n);
    if cbdel.checked then AddChatter('Leave:', RcvdNick);
    exit;
   end;

end;

procedure TForm1.IRCJoin(Sender: TObject; RcvdNick, RcvdFrom, RcvdID,
  RcvdCmd, RcvdMsg: String);
begin
 if RcvdNick = IRC.NickName then
  begin
   btnJoin.Enabled := False;
   btnPart.Enabled := True;
  end;
end;

procedure TForm1.IRCMode(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd,
  RcvdMsg: String);
begin
//
end;

procedure TForm1.IRCNames(Sender: TObject; RcvdName: String);
begin
//
end;

procedure TForm1.IRCNick(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd,
  RcvdMsg: String);
begin
//
end;

procedure TForm1.IRCPart(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd,
  RcvdMsg: String);
begin
 if pos(IRC.NickName, RcvdFrom) = 1 then
  begin
   lbNames.Items.Clear;
   btnPart.Enabled := False;
   btnJoin.Enabled := True;
   IrcChannel.Enabled := True;
  end;
end;

procedure TForm1.IRCQuit(Sender: TObject; RcvdFrom, RcvdID, RcvdCmd,
  RcvdMsg: String);
begin
//
end;

procedure TForm1.AddChatter(msgTitle, msgText: String);
begin
  while ilbChat.Items.Count > 200 do
   ilbChat.Items.Delete(0);

 ilbCHat.Items.add(msgTitle + '|'+ msgText);

 if not ilbChat.Focused then
  ilbChat.TopIndex := ilbChat.Items.Count -1;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 msgLog.Free;
end;

procedure TForm1.IRCMsgLog(Sender: TObject; RcvdNick, RcvdFrom, RcvdID,
  RcvdCmd, RcvdMsg, RcvdLine: String);
begin
//
end;

procedure TForm1.IRCNickSet(Sender: TObject; RcvdNick: String);
begin
 {Name of all people that are curently in this channel}
 lbNames.Items.Add(RcvdNick);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 Close;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
 Edit1.Width := pnlMessage.Width - 111;
 Edit2.Width := pnlMessage.Width - 111;
end;

end.
